pipeline {
  agent {
    label 'trbrdsdsh01'
  }
  stages {
    stage('Build') {
      steps {
        bat 'mvn clean install -DskipTests'
      }
    }
    stage('Tests') {
      steps {
        script {

          try {

            def ANDROID_HOME = 'C:/Users/adalberto.rizzon/AppData/Local/Android/Sdk'
            def ADB = "$ANDROID_HOME/platform-tools/adb"
            stage('Test') {
              //bat "$ANDROID_HOME/emulator/emulator -accel-check"
              bat "$ADB start-server"
              def error
              parallel(
                launchAppium: {
                  bat "Appium_Server.sh"
                },
                launchEmulator: {
                  bat "Pixel_4_API_28.sh"
                },
                runAndroidTests: {
//                   timeout(time: 80, unit: 'SECONDS') {
//                     bat "$ADB wait-for-device"
//                   }
                  try {
                    bat "mvn clean test -e -U"
                  } catch (e) {
                    error = e
                  }
                  bat "$ADB -e emu kill"
                  bat "$ADB kill-server"
                  bat "taskkill /F /IM node.exe"
                }
              )
              if (error != null) {
                throw error
              }
            }
            currentBuild.result = "SUCCESS"
          } catch (e) {
            currentBuild.result = "FAILED"
            //    notifyFailed()
            throw e
          } finally {
            stage('Report') {
              cucumber buildStatus: 'UNSTABLE',
                fileIncludePattern: "**/cucumberTestReport.json",
                jsonReportDirectory: 'target'
              archiveArtifacts artifacts: 'target/screenshots/**.png', fingerprint: true
            }
          }

        }
      }
    }
  }

}